/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.core.data;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import fr.cenra.rhomeo.api.Version;
import fr.cenra.rhomeo.core.util.VersionDeserializer;
import fr.cenra.rhomeo.core.util.VersionSerializer;
import fr.cenra.rhomeo.core.util.ZonedDateTimeDeserializer;
import fr.cenra.rhomeo.core.util.ZonedDateTimeSerializer;
import java.net.URL;
import java.time.ZonedDateTime;

/**
 * A simple pojo which contains information about application available package
 *
 * @author Alexis Manin (Geomatys)
 */
public class UpdateInfo {

    private Version version;
    private ZonedDateTime date;
    private String[] releaseNote;
    private URL win32;
    private String win32MD5;
    private URL deb64;
    private String deb64MD5;
    private URL rpm64;
    private String rpm64MD5;
    private URL macOS64;
    private String macOS64MD5;

    @JsonSerialize(using = VersionSerializer.class)
    public Version getVersion() {
        return version;
    }

    @JsonDeserialize(using = VersionDeserializer.class)
    public void setVersion(Version version) {
        this.version = version;
    }

    public URL getWin32() {
        return win32;
    }

    @JsonSerialize(using = ZonedDateTimeSerializer.class)
    public ZonedDateTime getDate() {
        return date;
    }

    @JsonDeserialize(using = ZonedDateTimeDeserializer.class)
    public void setDate(ZonedDateTime date) {
        this.date = date;
    }

    public String[] getReleaseNote() {
        return releaseNote;
    }

    public void setReleaseNote(String[] releaseNote) {
        this.releaseNote = releaseNote;
    }

    public void setWin32(URL win32) {
        this.win32 = win32;
    }

    public URL getDeb64() {
        return deb64;
    }

    public void setDeb64(URL deb64) {
        this.deb64 = deb64;
    }

    public URL getRpm64() {
        return rpm64;
    }

    public void setRpm64(URL rpm64) {
        this.rpm64 = rpm64;
    }

    public URL getMacOS64() {
        return macOS64;
    }

    public void setMacOS64(URL macOS64) {
        this.macOS64 = macOS64;
    }

    public String getWin32MD5() {
        return win32MD5;
    }

    public void setWin32MD5(String win32MD5) {
        this.win32MD5 = win32MD5;
    }

    public String getDeb64MD5() {
        return deb64MD5;
    }

    public void setDeb64MD5(String deb64MD5) {
        this.deb64MD5 = deb64MD5;
    }

    public String getRpm64MD5() {
        return rpm64MD5;
    }

    public void setRpm64MD5(String rpm64MD5) {
        this.rpm64MD5 = rpm64MD5;
    }

    public String getMacOS64MD5() {
        return macOS64MD5;
    }

    public void setMacOS64MD5(String macOS64MD5) {
        this.macOS64MD5 = macOS64MD5;
    }


}
